<?php

namespace Insign\PostCore\Api;

use Insign\PostCore\Api\Data\BarcodeInterface;
use Magento\Framework\Api\SearchCriteriaInterface;
use Magento\Framework\Exception\NoSuchEntityException;

/**
 * Interface BarcodeRepositoryInterface
 * @package Insign\PostCore\Api
 */
interface BarcodeRepositoryInterface
{
    /**
     * @param int $id
     * @throws NoSuchEntityException
     */
    public function getById(int $id);

    /**
     * @param BarcodeInterface $barcode
     */
    public function save(BarcodeInterface $barcode);

    /**
     * @param BarcodeInterface $barcode
     */
    public function delete(BarcodeInterface $barcode);

    /**
     * @param SearchCriteriaInterface $searchCriteria
     */
    public function getList(SearchCriteriaInterface $searchCriteria);
}
