<?php

namespace Insign\PostCore\Api;

use Insign\PostCore\Api\Data\TokenInterface;
use Magento\Framework\Api\SearchCriteriaInterface;
use Magento\Framework\Exception\NoSuchEntityException;

/**
 * Interface TokenRepositoryInterface
 * @package Insign\PostCore\Api
 */
interface TokenRepositoryInterface
{
    /**
     * @param int $id
     * @throws NoSuchEntityException
     */
    public function getById(int $id);

    /**
     * @param TokenInterface $token
     */
    public function save(TokenInterface $token);

    /**
     * @param TokenInterface $token
     */
    public function delete(TokenInterface $token);

    /**
     * @param SearchCriteriaInterface $searchCriteria
     */
    public function getList(SearchCriteriaInterface $searchCriteria);
}
