<?php

namespace Insign\PostCore\Block\Adminhtml\Barcode\Edit;

use Magento\Backend\Block\Widget\Context;
use Magento\Backend\Model\UrlInterface;
use Magento\Checkout\Model\Session;
use Magento\Framework\View\Element\UiComponent\Control\ButtonProviderInterface;

class BackButton extends GenericButton implements ButtonProviderInterface
{
    /**
     * @var UrlInterface
     */
    protected $url;
    /**
     * @var Session
     */
    private $session;

    /**
     * BackButton constructor.
     * @param Context $context
     * @param UrlInterface $url
     * @param Session $session
     */
    public function __construct(
        Context $context,
        UrlInterface $url,
        Session $session
    ) {
        parent::__construct($context);
        $this->url = $url;
        $this->session = $session;
    }

    /**
     * @return array
     */
    public function getButtonData(): array
    {
        return [
            'label' => __('Back'),
            'on_click' => sprintf("location.href = '%s';", $this->getBackUrl()),
            'class' => 'back',
            'sort_order' => 10
        ];
    }

    /**
     * Get URL for back (reset) button
     *
     * @return string
     */
    public function getBackUrl(): string
    {
        $id = $this->session->getVarValue();

        return $this->getUrl('sales/shipment/view/' , ['shipment_id' => $id]);
    }
}
