<?php

namespace Insign\PostCore\Logger;

class Log implements \Insign\PostCore\Api\LoggerInterface
{

    const LOG_FILE = 'swisspost.log';

    public function debug(string $message)
    {
        $this->_log("DEBUG: ", $message);
    }

    public function info(string $message)
    {
        $this->_log("INFO: ", $message);
    }

    public function warn(string $message)
    {
        $this->_log("WARN: ", $message);
    }

    public function error(string $message)
    {
        $this->_log("ERROR: ", $message);
    }

    private function _log(string $severity, string $message)
    {
        $filePath = implode(DIRECTORY_SEPARATOR, array(BP, "var", "log", self::LOG_FILE));
        $file = fopen($filePath, 'a');
        $t = microtime(true);
        $micro = sprintf("%06d", ($t - floor($t)) * 1000000);
        $now = new \DateTime();
        $date = $now->format("d.m.y H:i:s." . $micro);
        fwrite($file, "$date - $severity - $message \n");
        fclose($file);
    }
}
