<?php
namespace Insign\PostCore\Model;

use Insign\PostCore\Api\Data\TokenInterface;
use Magento\Catalog\Model\AbstractModel;

/**
 * Class Token
 * @package Insign\PostCore\Model
 */
class Token extends AbstractModel implements TokenInterface
{

    const ID = 'entity_id';
    const ACCESS_TOKEN = 'access_token';
    const SCOPE = 'scope';
    const CREATED_AT = 'created_at';
    const UPDATED_AT = 'updated_at';

    protected function _construct() {
        $this->_init(ResourceModel\Token::class);
    }

    /** @inheridoc  */
    public function getId()
    {
        return $this->_getData(self::ID);
    }

    public function getScope()
    {
        return $this->_getData(self::SCOPE);
    }

    public function setScope(string $scope)
    {
        $this->setData(self::SCOPE, $scope);
    }

    public function getAccessToken()
    {
        return $this->_getData(self::ACCESS_TOKEN);
    }

    public function setAccessToken(string $accessToken)
    {
        $this->setData(self::ACCESS_TOKEN, $accessToken);
    }

    public function getCreatedAt()
    {
        return $this->_getData(self::CREATED_AT);
    }

    public function getUpdatedAt()
    {
        return $this->_getData(self::UPDATED_AT);
    }

    public function setUpdatedAt(int $timestamp)
    {
        $this->setData(self::UPDATED_AT, $timestamp);
    }
}
